// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2019 HAProxy Technologies
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package http_error_rule

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"

	"github.com/go-openapi/runtime"

	"github.com/haproxytech/client-native/v5/models"
)

// GetHTTPErrorRulesOKCode is the HTTP code returned for type GetHTTPErrorRulesOK
const GetHTTPErrorRulesOKCode int = 200

/*
GetHTTPErrorRulesOK Successful operation

swagger:response getHttpErrorRulesOK
*/
type GetHTTPErrorRulesOK struct {
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *GetHTTPErrorRulesOKBody `json:"body,omitempty"`
}

// NewGetHTTPErrorRulesOK creates GetHTTPErrorRulesOK with default headers values
func NewGetHTTPErrorRulesOK() *GetHTTPErrorRulesOK {

	return &GetHTTPErrorRulesOK{}
}

// WithConfigurationVersion adds the configurationVersion to the get Http error rules o k response
func (o *GetHTTPErrorRulesOK) WithConfigurationVersion(configurationVersion string) *GetHTTPErrorRulesOK {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get Http error rules o k response
func (o *GetHTTPErrorRulesOK) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get Http error rules o k response
func (o *GetHTTPErrorRulesOK) WithPayload(payload *GetHTTPErrorRulesOKBody) *GetHTTPErrorRulesOK {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get Http error rules o k response
func (o *GetHTTPErrorRulesOK) SetPayload(payload *GetHTTPErrorRulesOKBody) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPErrorRulesOK) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(200)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}

/*
GetHTTPErrorRulesDefault General Error

swagger:response getHttpErrorRulesDefault
*/
type GetHTTPErrorRulesDefault struct {
	_statusCode int
	/*Configuration file version

	 */
	ConfigurationVersion string `json:"Configuration-Version"`

	/*
	  In: Body
	*/
	Payload *models.Error `json:"body,omitempty"`
}

// NewGetHTTPErrorRulesDefault creates GetHTTPErrorRulesDefault with default headers values
func NewGetHTTPErrorRulesDefault(code int) *GetHTTPErrorRulesDefault {
	if code <= 0 {
		code = 500
	}

	return &GetHTTPErrorRulesDefault{
		_statusCode: code,
	}
}

// WithStatusCode adds the status to the get HTTP error rules default response
func (o *GetHTTPErrorRulesDefault) WithStatusCode(code int) *GetHTTPErrorRulesDefault {
	o._statusCode = code
	return o
}

// SetStatusCode sets the status to the get HTTP error rules default response
func (o *GetHTTPErrorRulesDefault) SetStatusCode(code int) {
	o._statusCode = code
}

// WithConfigurationVersion adds the configurationVersion to the get HTTP error rules default response
func (o *GetHTTPErrorRulesDefault) WithConfigurationVersion(configurationVersion string) *GetHTTPErrorRulesDefault {
	o.ConfigurationVersion = configurationVersion
	return o
}

// SetConfigurationVersion sets the configurationVersion to the get HTTP error rules default response
func (o *GetHTTPErrorRulesDefault) SetConfigurationVersion(configurationVersion string) {
	o.ConfigurationVersion = configurationVersion
}

// WithPayload adds the payload to the get HTTP error rules default response
func (o *GetHTTPErrorRulesDefault) WithPayload(payload *models.Error) *GetHTTPErrorRulesDefault {
	o.Payload = payload
	return o
}

// SetPayload sets the payload to the get HTTP error rules default response
func (o *GetHTTPErrorRulesDefault) SetPayload(payload *models.Error) {
	o.Payload = payload
}

// WriteResponse to the client
func (o *GetHTTPErrorRulesDefault) WriteResponse(rw http.ResponseWriter, producer runtime.Producer) {

	// response header Configuration-Version

	configurationVersion := o.ConfigurationVersion
	if configurationVersion != "" {
		rw.Header().Set("Configuration-Version", configurationVersion)
	}

	rw.WriteHeader(o._statusCode)
	if o.Payload != nil {
		payload := o.Payload
		if err := producer.Produce(rw, payload); err != nil {
			panic(err) // let the recovery middleware deal with this
		}
	}
}
